Subject: Re: question about softirqs

From: Andi Kleen <[email-masked]>
Date: Wed, 13 May 2009 10:34:57 +0200

"Chris Friesen" <[email-masked]> writes:
>
> One of the reasons I brought up this issue is that there is a lot of
> documentation out there that says "softirqs will be processed on return
> from a syscall".  The fact that it actually depends on the scheduler
> parameters of the task issuing the syscall isn't ever mentioned.

It's not mentioned because it is not currently.

However some network TCP RX processing can happen in process context,
which gives you most of the benefit anyways.

> In fact, "Documentation/DocBook/kernel-hacking.tmpl" in the kernel
> source still has the following:
>
>     Whenever a system call is about to return to userspace, or a
>     hardware interrupt handler exits, any 'software interrupts'
>     which are marked pending (usually by hardware interrupts) are
>     run (<filename>kernel/softirq.c</filename>).
>
> If anyone is looking at changing this code, it might be good to ensure
> that at least the kernel docs are updated.

So far the code is not changed in mainline. There have been some
proposals only.

-Andi

-- 
[email-masked] -- Speaking for myself only.